# Copyright (C) 1998 - Martin Strauss - under terms of GPL
#####################################################
# show help
# ok !
proc Help {FILE Name} {
 global T
 global FocusEditorFlag FocusEditor
 global hlppath gifpath
 global I_txt I_hlp
 if [file exists "$hlppath/$FILE.txt"] then {
  set f [open "$hlppath/$FILE.txt" r]
  set txt [read $f]
  close $f
  if ![winfo exists .whelp] then {
   toplevel .whelp
   wm title .whelp $T(whelp-titel)
 
   frame .whelp.f

   scrollbar .whelp.f.vscroll -relief sunken -command {.whelp.f.l yview}

   text .whelp.f.l -yscroll {.whelp.f.vscroll set}
   .whelp.f.l insert 1.0 $txt
   .whelp.f.l configure -state disabled

   pack .whelp.f.vscroll  -side right -fill y
   pack .whelp.f.l -expand yes -fill both

   button .whelp.butQ -text $T(quit) -command {
    destroy .whelp
   }
   pack .whelp.f -expand yes -fill y
   pack .whelp.butQ
   COLOR .whelp
  } else {
   .whelp.f.l configure -state normal
   .whelp.f.l delete 1.0 end
   .whelp.f.l insert 1.0 $txt
   .whelp.f.l configure -state disabled
   focus .whelp
  }
  set ksp [.whelp.f.l search $Name 1.0]
  if {$ksp != ""} then {.whelp.f.l see $ksp}
 } {
  if [winfo exists .whelp] then {
   .whelp.f.l configure -state normal
   .whelp.f.l delete 1.0 end
   eval ".whelp.f.l insert 1.0 \"$T(whelp-no-source)\""
   .whelp.f.l configure -state disabled
  }
 }
 if [info exists I_txt($Name)] {
  if [file exists "$gifpath/$I_txt($Name).gif"] then {
   if ![winfo exists .whelpgif] then {
    toplevel .whelpgif
  
    button .whelpgif.butQ -image [Bild $Name] -command {
     destroy .whelpgif
    }
    pack .whelpgif.butQ
    COLOR .whelpgif
   } else {
    .whelpgif.butQ configure -image [Bild $Name]
    focus .whelpgif
   }
  } {
   if [winfo exists .whelpgif] then { 
    .whelpgif.butQ configure -image MasterBildSlaveOff
   }
  }
 } {
  if [winfo exists .whelpgif] then { 
   .whelpgif.butQ configure -image MasterBildSlaveOff
  }
 }
}
###############################################
# help from inside a text
# ok !
proc HelpTo {NAME} {
 global I_hlp T
 set flag 1
 set key [$NAME get insert insert+1c]
 if ![string compare $key "\\"] then {
  set strt insert+1c
 } else {
  set strt insert
 }
 set ID [array startsearch I_hlp] 
 while {[array anymore I_hlp $ID]} {
  set elm [array nextelement I_hlp $ID]
  set velm [$NAME get $strt insert+[expr [string length $elm] + 1]c]
  if ![string compare $elm $velm] then {
   Help $I_hlp($elm) $elm
   set flag 0
  }
 }
 array donesearch I_hlp $ID
 if $flag then {
   Help editor_hlp $T(Helpto-Help)
 }
}